// Palindrome Checker developed in Lecture 28 on Tuesday (12/3) in-class.
#include <iostream>
#include <vector>
#include <string>
#include <cctype> // C char functions:  isalpha and islower
using namespace std;

int main () {
  vector<char> myCharVector;
  vector<char>::iterator left, right;
  string myString;

  cout << "Enter the string you want to check for a palindrome: ";
  getline(cin, myString);

  // transfer from myString to myCharVector
  for (int index = 0; index < myString.size(); index++) {
    // if (myString[index] != ' ') { works, but a better check is:
    if (isalpha(myString[index])) {
      myCharVector.push_back(tolower(myString[index]));
	} // end if
  } // end for

  // Check for palindrome in myCharVector
  left = myCharVector.begin();
  right = myCharVector.end(); // point next position after the end of the vector
  right--;  // gets it to point to the last character in the vector

  while (true) {
    if (left >=  right) {  
      cout << "\"" << myString << "\" IS a palindrome!" << endl;
      break;
    } // end if
    if (*left != *right) {
      cout << "\"" << myString << "\" IS NOT a palindrome!" << endl;
      break;
    } else {
      left++;
      right--;
    } // end if
  } // end while

  return 0;
} // end main
